/***************************************************************************
  BurstProc.c   - Dialog box procedures for BURST.C
  *************************************************************************/

#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "resource.h"
#include "burst.h"

extern char szBinWidths[];
extern double BinWidths[];

#define NUMSUMSTEPS     9
char szSumSteps[NUMSUMSTEPS][5] = {"2","4","8","12","16","24","32","64", "128"};
WORD nSumSteps[NUMSUMSTEPS] = {2, 4, 8, 12, 16, 24, 32, 64, 128};   

/********************************************************************************************
  Photon Stream (counts) display setup dialog box
  *****************************************************************************************/
BOOL CALLBACK CountsSetupProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
 char szBuf[80];

 switch (message)    {
      case WM_INITDIALOG:

		  CheckRadioButton(hDlg, IDC_CD_AVE, IDC_CD_SINGLE, init.Displaymode);
		  sprintf(szBuf,"%4.1f",init.c1);
		  SendDlgItemMessage(hDlg,IDC_C1, WM_SETTEXT,sizeof(szBuf),(LPARAM)((LPSTR) szBuf));
          sprintf(szBuf,"%4.1f",init.c2);
		  SendDlgItemMessage(hDlg,IDC_C2, WM_SETTEXT,sizeof(szBuf),(LPARAM)((LPSTR) szBuf));
          sprintf(szBuf,"%1.3f",init.a1);
		  SendDlgItemMessage(hDlg,IDC_A1, WM_SETTEXT,sizeof(szBuf),(LPARAM)((LPSTR) szBuf));
          sprintf(szBuf,"%1.3f",init.a2);
		  SendDlgItemMessage(hDlg,IDC_A2, WM_SETTEXT,sizeof(szBuf),(LPARAM)((LPSTR) szBuf));
          sprintf(szBuf,"%1.3f",init.rab);
		  SendDlgItemMessage(hDlg,IDC_RAB, WM_SETTEXT,sizeof(szBuf),(LPARAM)((LPSTR) szBuf));
          sprintf(szBuf,"%1.3f",init.rba);
		  SendDlgItemMessage(hDlg,IDC_RBA, WM_SETTEXT,sizeof(szBuf),(LPARAM)((LPSTR) szBuf));
		  return (TRUE);
      
	  case WM_COMMAND:
	      switch (wParam) {
			case IDOK: 
               if(IsDlgButtonChecked(hDlg, IDC_CD_AVE)) cd.Displaymode = IDC_CD_AVE;
               if(IsDlgButtonChecked(hDlg, IDC_CD_SUM)) cd.Displaymode = IDC_CD_SUM;
               if(IsDlgButtonChecked(hDlg, IDC_CD_SINGLE)) cd.Displaymode = IDC_CD_SINGLE;
		       CheckRadioButton(hDlg, IDC_CD_AVE, IDC_CD_SINGLE, cd.Displaymode);
			   init.Displaymode = cd.Displaymode;     // save value to ini file
		  	   // if in sum mode - switch to autoscale so data will show up: 
			   if(cd.Displaymode == IDC_CD_SUM && !init.bAutoScale) ToggleCountsAutoScale();    
			   SendDlgItemMessage(hDlg, IDC_C1, WM_GETTEXT,sizeof(szBuf),(LPARAM)((LPSTR) szBuf));
               init.c1 = atof(szBuf);
			   SendDlgItemMessage(hDlg, IDC_C2, WM_GETTEXT,sizeof(szBuf),(LPARAM)((LPSTR) szBuf));
               init.c2 = atof(szBuf);
			   SendDlgItemMessage(hDlg, IDC_A1, WM_GETTEXT,sizeof(szBuf),(LPARAM)((LPSTR) szBuf));
               init.a1 = atof(szBuf);
			   SendDlgItemMessage(hDlg, IDC_A2, WM_GETTEXT,sizeof(szBuf),(LPARAM)((LPSTR) szBuf));
               init.a2 = atof(szBuf);
			   SendDlgItemMessage(hDlg, IDC_RAB, WM_GETTEXT,sizeof(szBuf),(LPARAM)((LPSTR) szBuf));
               init.rab = atof(szBuf);
			   init.f1 = init.rab / (init.rab + 1.0); 
			   SendDlgItemMessage(hDlg, IDC_RBA, WM_GETTEXT,sizeof(szBuf),(LPARAM)((LPSTR) szBuf));
               init.rba = atof(szBuf);
   			   init.f2 = init.rba / (init.rba + 1.0); 
			   EndDialog(hDlg, FALSE);
		       return(TRUE);
			 
		case IDCANCEL: 
	       	   EndDialog(hDlg, TRUE);
    	       return (TRUE);
		}
    }
    return (FALSE);
}



/********************************************************************************************
  Histogram plotting display setup dialog box
  *****************************************************************************************/
BOOL CALLBACK HistSetupProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
 char szBuf[80];
 static int BinIndex;
 DWORD dwVal;


 switch (message)    {
      case WM_INITDIALOG:
		  sprintf(szBuf,"%5.2f", init.BurstBinsize);
		  SendDlgItemMessage(hDlg,IDC_BURSTHISTBINSIZE, WM_SETTEXT,sizeof(szBuf),(LPARAM)((LPSTR) szBuf));
		  sprintf(szBuf,"%5.2f", init.WidthBinsize);
		  SendDlgItemMessage(hDlg,IDC_WIDTHHISTBINSIZE, WM_SETTEXT,sizeof(szBuf),(LPARAM)((LPSTR) szBuf));
		  sprintf(szBuf,"%2.5f", init.IntervalBinsize);
		  SendDlgItemMessage(hDlg,IDC_INTERVALHISTBINSIZE, WM_SETTEXT,sizeof(szBuf),(LPARAM)((LPSTR) szBuf));
		  sprintf(szBuf,"%d",init.NumHistBins);
		  SendDlgItemMessage(hDlg,IDC_MAXHISTBINS, WM_SETTEXT,sizeof(szBuf),(LPARAM)((LPSTR) szBuf));
		  if(init.bShowHistDialog) CheckDlgButton(hDlg,  IDC_SHOWHISTSETUP,  BST_CHECKED);
		  return (TRUE);
      
	  case WM_COMMAND:
	      switch (wParam) {
			case IDOK: 
			   // photons per burst histogram parameters
		   	   SendDlgItemMessage(hDlg, IDC_BURSTHISTBINSIZE, WM_GETTEXT,sizeof(szBuf),(LPARAM)((LPSTR) szBuf));
               init.BurstBinsize =  atof(szBuf);
			  
			   // burst width histogram parameters
			   SendDlgItemMessage(hDlg, IDC_WIDTHHISTBINSIZE, WM_GETTEXT,sizeof(szBuf),(LPARAM)((LPSTR) szBuf));
               init.WidthBinsize =  atof(szBuf);
			   
			   // interval histogram parameters
			   SendDlgItemMessage(hDlg, IDC_INTERVALHISTBINSIZE, WM_GETTEXT,sizeof(szBuf),(LPARAM)((LPSTR) szBuf));
               init.IntervalBinsize =  atof(szBuf);
			  
			   SendDlgItemMessage(hDlg, IDC_MAXHISTBINS, WM_GETTEXT,sizeof(szBuf),(LPARAM)((LPSTR) szBuf));
               dwVal = (DWORD) atof(szBuf);
			   init.NumHistBins = (dwVal < QC_SIZE) ? dwVal : QC_SIZE;
			   
			   init.bShowHistDialog = (IsDlgButtonChecked(hDlg,  IDC_SHOWHISTSETUP)) ? TRUE : FALSE; 
   			   init.bAppendBurstResults = (IsDlgButtonChecked(hDlg,  IDC_APPENDBURSTDATA)) ? TRUE : FALSE; 
			   EndDialog(hDlg, FALSE);
		       return(TRUE);
			 
		case IDCANCEL: 
	       	   EndDialog(hDlg, TRUE);
    	       return (TRUE);
		}
    }
    return (FALSE);
}


/********************************************************************************************
  FCS display setup dialog box
  *****************************************************************************************/
BOOL CALLBACK FCSSetupProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
 int i;
 AUTOCORRELATION *fcs = GETFCS(active_ps); 

 switch (message)    {
      case WM_INITDIALOG:
		  for(i=0;i<NUMSUMSTEPS;i++) SendMessage(GetDlgItem(hDlg, IDC_SUMSTEP), CB_ADDSTRING, 0, (LPARAM) (LPCSTR) szSumSteps[i]);
          i = GetIndexWord(init.SumStep, nSumSteps, NUMSUMSTEPS);
          SendMessage(GetDlgItem(hDlg, IDC_SUMSTEP), CB_SETCURSEL, (WPARAM) i,  0);
		  SetUpBinWidths(hDlg, init.FCSBinWidth);
		  if(init.bShowFCSDialog) CheckDlgButton(hDlg,  IDC_SHOWFCSSETUP,  BST_CHECKED);
		  return (TRUE);
      
	  case WM_COMMAND:
	      switch (wParam) {
			case IDOK: 
   			   init.FCSBinWidth = GetBinWidth(hDlg);      // save new user selected value
			   i = SendDlgItemMessage(hDlg, IDC_SUMSTEP, CB_GETCURSEL, 0, 0);
		       init.SumStep = nSumSteps[i];
			   init.bShowFCSDialog = (IsDlgButtonChecked(hDlg,  IDC_SHOWFCSSETUP)) ? TRUE : FALSE; 
			   EndDialog(hDlg, FALSE);
		       return(TRUE);
			 
		case IDCANCEL: 
	       	   EndDialog(hDlg, TRUE);
    	       return (TRUE);
		}
    }
    return (FALSE);
}

/********************************************************************************************
  Segmental autocorrelation setup procedure
  *****************************************************************************************/
BOOL CALLBACK SegmentedAutocorrelationProc(HWND hDlg, UINT message, WPARAM wParam,  LPARAM lParam)
{
  int i;
  char szBuf[256];
  double mintime;
  BURST *burst = GETBURST(active_ps);
  AUTOCORRELATION *fcs = GETFCS(active_ps); 
  PHOTON_STREAM *ps = GETPS(active_ps);


  switch (message)  {
     case WM_INITDIALOG:
 		      sprintf(szBuf,"%s", burst->szFilename);
		      SendDlgItemMessage(hDlg, IDC_SEGAC_FILENAME, WM_SETTEXT, sizeof(szBuf), (LPARAM)((LPSTR) szBuf));
		      for(i=0;i<NUMSUMSTEPS;i++) SendMessage(GetDlgItem(hDlg, IDC_SUMSTEP), CB_ADDSTRING, 0, (LPARAM) (LPCSTR) szSumSteps[i]);
              i = GetIndexWord(init.SegSumStep, nSumSteps, NUMSUMSTEPS);
              SendMessage(GetDlgItem(hDlg, IDC_SUMSTEP), CB_SETCURSEL, (WPARAM) i,  0);
 		      sprintf(szBuf,"%5.1f",init.SegMinTime);
			  fcs->sumstep = init.SumStep; 
		      SendDlgItemMessage(hDlg, IDC_SAC_MINTIME, WM_SETTEXT, sizeof(szBuf), (LPARAM)((LPSTR) szBuf));
			  fcs->mintime = init.SegMinTime; 
			  SetUpBinWidths(hDlg, init.FCSBinWidth);
			  fcs->binwidth = init.FCSBinWidth; 
			  SegmentAnalysis(burst, fcs, ps->nbins);
			  sprintf(szBuf, "%u out of %u", fcs->nave, fcs->numseg); 
			  SendDlgItemMessage(hDlg, IDC_SAC_NUMSEG, WM_SETTEXT, sizeof(szBuf), (LPARAM)((LPSTR) szBuf));
			  return (TRUE);

     case WM_COMMAND:
		switch(wParam) {
		  case IDC_SEGMINTIME_RESET: 
		       SendDlgItemMessage(hDlg, IDC_SAC_MINTIME, WM_GETTEXT, sizeof(szBuf), (LPARAM)((LPSTR) szBuf));
     		   mintime = atof(szBuf);
			   fcs->binwidth = GetBinWidth(hDlg);
			   init.FCSBinWidth = fcs->binwidth;
			   if(mintime < init.FCSBinWidth) {
				   fcs->mintime = init.FCSBinWidth;
				   init.SegMinTime = fcs->mintime; 
		           sprintf(szBuf,"%5.1f",init.SegMinTime);
		           SendDlgItemMessage(hDlg, IDC_SAC_MINTIME, WM_SETTEXT, sizeof(szBuf), (LPARAM)((LPSTR) szBuf));
			   }
			   ReSegmentAnalysis(burst, fcs);
			   sprintf(szBuf, "%u out of %u", fcs->nave, fcs->numseg); 
			   SendDlgItemMessage(hDlg, IDC_SAC_NUMSEG, WM_SETTEXT, sizeof(szBuf), (LPARAM)((LPSTR) szBuf));
			   
			   return(TRUE);

		  case IDC_SAC:
               fcs->binwidth = GetBinWidth(hDlg);
			   init.FCSBinWidth = fcs->binwidth;      // save new user selected value
   		       SendDlgItemMessage(hDlg, IDC_SAC_MINTIME, WM_GETTEXT, sizeof(szBuf), (LPARAM)((LPSTR) szBuf));
               fcs->mintime = atof(szBuf);
			   init.SegMinTime = fcs->mintime;  // save new user selected value
   			   ReSegmentAnalysis(burst, fcs);
   	   	       i = SendDlgItemMessage(hDlg, IDC_SUMSTEP, CB_GETCURSEL, 0, 0);
	           init.SumStep = nSumSteps[i];
			   EndDialog(hDlg, FALSE);
			   return(TRUE);	
		
		  case IDCANCEL:
	   	       EndDialog(hDlg, TRUE);
    		   return (FALSE);
	    }
	    
    }
    return (FALSE);
}



//  About box proc
BOOL CALLBACK AboutProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
  switch (message)  {
   	case WM_INITDIALOG:
         return (TRUE);

   	case WM_COMMAND:
	    if (wParam == IDOK || wParam == IDCANCEL)  {
		    EndDialog(hDlg, TRUE);
    		return (TRUE);
	    }
	    break;
    }
    return (FALSE);
}



int GetIndex(double nValue, double *nBuf, int n)
{
 int i = 0;
 
 while(i < n) {
	 if(nBuf[i] == nValue) 
		 return(i);
	 else
		 i++;
 }
 return(0);
}

int GetIndexWord(WORD nValue, WORD *nBuf, int n)
{
 int i = 0;
 
 while(i < n) {
	 if(nBuf[i] == nValue) 
		 return(i);
	 else
		 i++;
 }
 return(0);
}


